#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 White
#property indicator_color4 White
#property indicator_color5 Silver
#property indicator_color6 DodgerBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//

#include <WebGet.mqh>

//
//
//
//
//

extern string   xx                        = "==Mandarine==";
extern int      T3Period                  = 5;
extern int      T3Price                   = PRICE_CLOSE;
extern double   T3Hot                     = 0.7;
extern bool     T3Original                = false;
extern int      Fast                      = 5;
extern int      Slow                      = 20; 

extern string   x                         = "==Mandarine Alerts And Arrows==";
extern bool     alertsOn                  = true;
extern bool     alertsOnCurrent           = true;
extern bool     alertsMessage             = true;
extern bool     alertsSound               = true;
extern bool     alertsEmail               = false;
extern string   soundfile                 = "alert2.wav";
extern string   note7                     = "Arrow Type";
extern string   note8                     = "0=default,1=Thick,2=Thin,3=Hollow";
extern string   note9                     = "4=Round,5=Fractal,6=Diagonal Thin";
extern string   note10                    = "7=Diagonal Thick,8=Diagonal Hollow";
extern string   note11                    = "9=Thumb,10=Finger";
extern int      ArrowType                 = 2;

extern string   HeikenAshiSetting         = "==HeikenAshi Settings==";
extern bool     ShowHeikenAshi            = true; 
extern int      Length                    = 20;
extern double   Phase                     = 0;
extern bool     Double                    = false;
extern int      Step                      = 1;
extern bool     BetterFormula             = true;

extern string   MMSetting                 = "==Murray Math Settings==";
extern int      P                         = 64;
extern int      MMPeriod                  = 1440;
extern int      StepBack                  = 0;
extern int      ShowDays                  = 10;
extern bool     babylines                 = true;
extern int      babyLinesStyle            = STYLE_SOLID;
extern bool     fiftyPercentLine          = true;
extern int      fiftyPercentLineStyle     = STYLE_DASH;
extern bool     MMalertsOn                = false;
extern double   MMalertsTolerance         = 1.0;
extern bool     touchChanell              = false;
extern bool     MMalertsOnCurrent         = false;
extern bool     MMalertsMessage           = true;
extern bool     MMalertsSound             = false;
extern bool     MMalertsEmail             = false;
extern bool     MMalertsShowTouched       = true;
extern int      barsToShowCandles         = 1000;
extern color    BarUpColor                = Green; 
extern color    BarDownColor              = Red; 
extern color    BabyBarUpColor            = Lime; 
extern color    BabyBarDownColor          = Pink; 
extern color    WickColor                 = Gray;
extern int      CandleWidth               = 3;

extern color    mml_clr_m_2_8             = White;       // [-2]/8
extern color    mml_clr_m_1_8             = White;       // [-1]/8
extern color    mml_clr_0_8               = Aqua;        //  [0]/8
extern color    mml_clr_1_8               = Yellow;      //  [1]/8
extern color    mml_clr_2_8               = Red;         //  [2]/8
extern color    mml_clr_3_8               = Green;       //  [3]/8
extern color    mml_clr_4_8               = Blue;        //  [4]/8
extern color    mml_clr_5_8               = Green;       //  [5]/8
extern color    mml_clr_6_8               = Red;         //  [6]/8
extern color    mml_clr_7_8               = Yellow;      //  [7]/8
extern color    mml_clr_8_8               = Aqua;        //  [8]/8
extern color    mml_clr_p_1_8             = White;       // [+1]/8
extern color    mml_clr_p_2_8             = White;       // [+2]/8

extern int      mml_wdth_m_2_8            = 2;           // [-2]/8
extern int      mml_wdth_m_1_8            = 1;           // [-1]/8
extern int      mml_wdth_0_8              = 1;           //  [0]/8
extern int      mml_wdth_1_8              = 1;           //  [1]/8
extern int      mml_wdth_2_8              = 1;           //  [2]/8
extern int      mml_wdth_3_8              = 1;           //  [3]/8
extern int      mml_wdth_4_8              = 1;           //  [4]/8
extern int      mml_wdth_5_8              = 1;           //  [5]/8
extern int      mml_wdth_6_8              = 1;           //  [6]/8
extern int      mml_wdth_7_8              = 1;           //  [7]/8
extern int      mml_wdth_8_8              = 1;           //  [8]/8
extern int      mml_wdth_p_1_8            = 1;           // [+1]/8
extern int      mml_wdth_p_2_8            = 2;           // [+2]/8
 
extern color    MarkColor                 = Blue;
extern int      MarkNumber                = 217;

extern string   CalendarName              = "ForexTSD";
extern int      CalendarID                = 4;            // Calendar's ID on calendar.forex-tsd.com  
extern bool     UseStartDate              = false; 
extern datetime StartDate                 = D'2007.04.10';      
extern bool     AlertMode                 = false;
extern int      AlertTimeGap              = 1;            // Time Gap between News Time and Alert Time in min 
extern bool     DisplayLine               = false;        // Display Line Option (Visualization mode) 
extern bool     DisplayText               = false;        // Display Text Option (Visualization mode)

extern string   cFilter                   = "Currency Filter";
extern bool     USD                       = true;
extern bool     EUR                       = true;
extern bool     GBP                       = true;
extern bool     JPY                       = true;
extern bool     AUD                       = true;
extern bool     CAD                       = true;
extern bool     CHF                       = true;
extern bool     NZD                       = true;

extern string   rFilter                   = "Rating Filter";
extern int      MaxRating                 = 3;
extern int      MinRating                 = 1;  

//
//
//
//
//

double   CrossUp[];
double   CrossDn[];
double   Buffer1[];
double   Buffer2[];
double   Buffer3[];
double   Buffer4[];
double   t3[];
double   trend[];

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
string   sImpact[1000];
string   sComment = "";
datetime dt[1000];    
int      NewsNum;
bool     fTime;
datetime prevTime, nnTime, OpenTime;
int      TimeZone;

//
//
//
//
//

double   dmml = 0,
         dvtl = 0,
         sum  = 0,
         v1 = 0,
         v2 = 0,
         mn = 0,
         mx = 0,
         x1 = 0,
         x2 = 0,
         x3 = 0,
         x4 = 0,
         x5 = 0,
         x6 = 0,
         y1 = 0,
         y2 = 0,
         y3 = 0,
         y4 = 0,
         y5 = 0,
         y6 = 0,
         octave = 0,
         fractal = 0,
         range   = 0,
         finalH  = 0,
         finalL  = 0,
         mml[13];

string   ln_txt[13],        
         buff_str = "";
        
int     
         bn_v1   = 0,
         bn_v2   = 0,
         OctLinesCnt = 13,
         mml_thk = 8,
         mml_clr[13],
         mml_wdth[13],
         mml_shft = 0,
         nTime = 0,
         CurPeriod = 0,
         nDigits = 0,
         i = 0;
int      NewPeriod=0;
int      ShowPeriod;
double   values[49];
int      totalCandles;
string   windowID;
double   pointvalue = 1;

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {
   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
   
   IndicatorBuffers(8);
   
   IndicatorDigits(Digits);
   switch(ArrowType)
   {
      case 0  : int arrowUp = 119; int arrowDown=119; break;
      case 1  :     arrowUp = 233;     arrowDown=234; break;
      case 2  :     arrowUp = 225;     arrowDown=226; break;
      case 3  :     arrowUp = 241;     arrowDown=242; break;
      case 4  :     arrowUp = 221;     arrowDown=222; break;
      case 5  :     arrowUp = 217;     arrowDown=218; break;
      case 6  :     arrowUp = 228;     arrowDown=230; break;
      case 7  :     arrowUp = 236;     arrowDown=238; break;
      case 8  :     arrowUp = 246;     arrowDown=248; break;
      case 9  :     arrowUp =  67;     arrowDown= 68; break;
      case 10 :     arrowUp =  71;     arrowDown= 72; break;
   }  
       
   SetIndexBuffer(0,CrossUp); SetIndexEmptyValue(0,0); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,arrowUp);   SetIndexLabel(0,"Mandarine Up");
   SetIndexBuffer(1,CrossDn); SetIndexEmptyValue(1,0); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,arrowDown); SetIndexLabel(1,"Mandarine Down");
   SetIndexBuffer(2,Buffer1); SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,Buffer2); SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4,Buffer3); SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(5,Buffer4); SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(6,t3); 
   SetIndexBuffer(7,trend);
   
   windowID  = "Mano MM"+MMPeriod;
   if(MMPeriod>0) NewPeriod   = P*MathCeil(MMPeriod/Period());
   else           NewPeriod = P;
   
   ln_txt[0]  = "[-2/8]P";  // "extremely overshoot [-2/8]";// [-2/8]
   ln_txt[1]  = "[-1/8]P";  // "overshoot [-1/8]";// [-1/8]
   ln_txt[2]  = "[0/8]P";   // "Ultimate Support - extremely oversold [0/8]";// [0/8]
   ln_txt[3]  = "[1/8]P";   // "Weak, Stall and Reverse - [1/8]";// [1/8]
   ln_txt[4]  = "[2/8]P";   // "Pivot, Reverse - major [2/8]";// [2/8]
   ln_txt[5]  = "[3/8]P";   // "Bottom of Trading Range - [3/8], if 10-12 bars then 40% Time. BUY Premium Zone";//[3/8]
   ln_txt[6]  = "[4/8]P";   // "Major Support/Resistance Pivotal Point [4/8]- Best New BUY or SELL level";// [4/8]
   ln_txt[7]  = "[5/8]P";   // "Top of Trading Range - [5/8], if 10-12 bars then 40% Time. SELL Premium Zone";//[5/8]
   ln_txt[8]  = "[6/8]P";   // "Pivot, Reverse - major [6/8]";// [6/8]
   ln_txt[9]  = "[7/8]P";   // "Weak, Stall and Reverse - [7/8]";// [7/8]
   ln_txt[10] = "[8/8]P";   // "Ultimate Resistance - extremely overbought [8/8]";// [8/8]
   ln_txt[11] = "[+1/8]P";  // "overshoot [+1/8]";// [+1/8]
   ln_txt[12] = "[+2/8]P";  // "extremely overshoot [+2/8]";// [+2/8]

   mml_thk  = 3;
   mml_clr[0]  = mml_clr_m_2_8;   mml_wdth[0] = mml_wdth_m_2_8; // [-2]/8
   mml_clr[1]  = mml_clr_m_1_8;   mml_wdth[1] = mml_wdth_m_1_8; // [-1]/8
   mml_clr[2]  = mml_clr_0_8;     mml_wdth[2] = mml_wdth_0_8;   //  [0]/8
   mml_clr[3]  = mml_clr_1_8;     mml_wdth[3] = mml_wdth_1_8;   //  [1]/8
   mml_clr[4]  = mml_clr_2_8;     mml_wdth[4] = mml_wdth_2_8;   //  [2]/8
   mml_clr[5]  = mml_clr_3_8;     mml_wdth[5] = mml_wdth_3_8;   //  [3]/8
   mml_clr[6]  = mml_clr_4_8;     mml_wdth[6] = mml_wdth_4_8;   //  [4]/8
   mml_clr[7]  = mml_clr_5_8;     mml_wdth[7] = mml_wdth_5_8;   //  [5]/8
   mml_clr[8]  = mml_clr_6_8;     mml_wdth[8] = mml_wdth_6_8;   //  [6]/8
   mml_clr[9]  = mml_clr_7_8;     mml_wdth[9] = mml_wdth_7_8;   //  [7]/8
   mml_clr[10] = mml_clr_8_8;     mml_wdth[10]= mml_wdth_8_8;   //  [8]/8
   mml_clr[11] = mml_clr_p_1_8;   mml_wdth[11]= mml_wdth_p_1_8; // [+1]/8
   mml_clr[12] = mml_clr_p_2_8;   mml_wdth[12]= mml_wdth_p_2_8; // [+2]/8
   
   switch(Period())
   {
      case PERIOD_MN1:
      case PERIOD_W1:  ShowPeriod = PERIOD_MN1; break;
      case PERIOD_D1:  ShowPeriod = PERIOD_W1;  break;
      default:         ShowPeriod = PERIOD_D1;
   } 
   
   return(0);
}

//
//
//
//
//

int deinit()
{
   for(i=0;i<OctLinesCnt;i++) ObjectDelete("mml_txt"+i);
   for(i=0;i<50;i++)          ObjectDelete("MMline"+i);
                              ObjectDelete("LR_LatestCulcBar");
   deleteCandles();
     
   Comment("");
   
   ObjDel();
   
   fTime = true;
                               
   return(0);
}

//------------------------------------------------------------------  
//
//
//
//------------------------------------------------------------------

int start() 
{
   
   if (!IsDllsAllowed()) {
       Alert( " DLLs are disabled.  To enable tick the checkbox in the Common Tab of indicator" );
     return;
   }
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
             t3[i]  = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i);
      double emaf11 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,i);
      double emas21 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,i);
      
   	   trend[i] = trend[i+1];
         if (emaf11 > emas21 && emaf11 > t3[i]) trend[i] =  1;
         if (emaf11 < emas21 && emaf11 < t3[i]) trend[i] = -1;
         
         //
         //
         //
         //
         //
         
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;     
         
   }
  
   //
   //         
   //+------------------------------------------------------------------+
   //| Heiken Ashi indicator iteration function                              
   //+------------------------------------------------------------------+

   if (ShowHeikenAshi)
   {           
      for(i=limit; i>=0; i--)
      {
      double maOpen  = iDSmooth(Open[i], Length,Phase,Double,i, 0);
      double maClose = iDSmooth(Close[i],Length,Phase,Double,i,20);
      double maLow   = iDSmooth(Low[i],  Length,Phase,Double,i,40);
      double maHigh  = iDSmooth(High[i], Length,Phase,Double,i,60);
      
      //
      //
      //
      //
      //
        
      if (BetterFormula) {
               if (maHigh!= maLow)
                     double haClose = (maOpen + maClose)/2+(((maClose - maOpen)/(maHigh  -maLow)) * MathAbs((maClose - maOpen)/2));
               else  haClose = (maOpen + maClose)/2; }
         else        haClose = (maOpen + maHigh + maLow + maClose)/4;
                     double haOpen   = (Buffer3[i+1] + Buffer4[i+1])/2;
                     double haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     double haLow    = MathMin(maOpen, MathMin(haOpen,haClose));

         if (haOpen < haClose) { Buffer1[i] = haLow;  Buffer2[i] = haHigh; } 
         else                  { Buffer1[i] = haHigh; Buffer2[i] = haLow;  } 
                                 Buffer3[i] = haOpen;
                                 Buffer4[i] = haClose;
      
      //
      //
      //
      //
      //

      if (Step > 0)
      {
         if(MathAbs(Buffer1[i] - Buffer1[i+1]) < Step * pointvalue) Buffer1[i] = Buffer1[i+1];
         if(MathAbs(Buffer2[i] - Buffer2[i+1]) < Step * pointvalue) Buffer2[i] = Buffer2[i+1];
         if(MathAbs(Buffer3[i] - Buffer3[i+1]) < Step * pointvalue) Buffer3[i] = Buffer3[i+1];
         if(MathAbs(Buffer4[i] - Buffer4[i+1]) < Step * pointvalue) Buffer4[i] = Buffer4[i+1];
      } 
      }
      }
 
      //
      //
      //
      //
      //
      
      if( (nTime != Time[0]) || (CurPeriod != Period()) )
      {
      ArrayInitialize(values,0.00);
      bn_v1 = iLowest( NULL,0,MODE_LOW, NewPeriod+StepBack,StepBack);
      bn_v2 = iHighest(NULL,0,MODE_HIGH,NewPeriod+StepBack,StepBack);
      v1    = Low[bn_v1];
      v2    = High[bn_v2];
      while (true)
      {
         if( v2 > 25000 )    { fractal=100000;    break; }
         if( v2 > 2500 )     { fractal=10000;     break; }
         if( v2 > 250 )      { fractal=1000;      break; }
         if( v2 > 25 )       { fractal=100;       break; }
         if( v2 > 6.25 )     { fractal=12.5;      break; }
         if( v2 > 3.125 )    { fractal=6.25;      break; }
         if( v2 > 1.5625 )   { fractal=3.125;     break; }
         if( v2 > 0.390625 ) { fractal=1.5625;    break; }
         if( v2 > 0 )        { fractal=0.1953125; break; }
                                                  break;
      }                                            
      
      range  = (v2-v1);
      sum    = MathFloor(MathLog(fractal/range)/MathLog(2));
      octave = fractal*(MathPow(0.5,sum));
      mn     = MathFloor(v1/octave)*octave;

      if( (mn+octave)>v2 )
            mx=mn+octave; 
      else  mx=mn+(2*octave);


      //x2 
            if( (v1>=(3*(mx-mn)/16+mn)) && (v2<=(9*(mx-mn)/16+mn)) )
                 x2=mn+(mx-mn)/2; 
            else x2=0;
      //x1
            if( (v1>=(mn-(mx-mn)/8))&& (v2<=(5*(mx-mn)/8+mn)) && (x2==0) )
                 x1=mn+(mx-mn)/2; 
            else x1=0;
      //x4
            if( (v1>=(mn+7*(mx-mn)/16))&& (v2<=(13*(mx-mn)/16+mn)) )
                 x4=mn+3*(mx-mn)/4; 
            else x4=0;
      //x5
            if( (v1>=(mn+3*(mx-mn)/8))&& (v2<=(9*(mx-mn)/8+mn))&& (x4==0) )
                 x5=mx; 
            else x5=0;
      //x3
            if( (v1>=(mn+(mx-mn)/8))&& (v2<=(7*(mx-mn)/8+mn))&& (x1==0) && (x2==0) && (x4==0) && (x5==0) )
                 x3=mn+3*(mx-mn)/4; 
            else x3=0;
      //x6
            if( (x1+x2+x3+x4+x5) ==0 )
                 x6=mx; 
            else x6=0;

      //
      //
      //
      //
      //
      
      finalH = x1+x2+x3+x4+x5+x6;

      //y1
         if( x1>0 )
              y1=mn; 
         else y1=0;
      //y2
         if( x2>0 )
              y2=mn+(mx-mn)/4; 
         else y2=0;
      //y3
         if( x3>0 )
              y3=mn+(mx-mn)/4; 
         else y3=0;
      //y4
         if( x4>0 )
              y4=mn+(mx-mn)/2; 
         else y4=0;
      //y5
         if( x5>0 )
              y5=mn+(mx-mn)/2; 
         else y5=0;
      //y6
         if( (finalH>0) && ((y1+y2+y3+y4+y5)==0) )
              y6=mn; 
         else y6=0;

      //
      //
      //
      //
      //
    
      finalL = y1+y2+y3+y4+y5+y6;

      ArrayInitialize(mml,0); //  for( i=0; i<OctLinesCnt; i++) {  mml[i] = 0; }
      dmml   = (finalH-finalL)/8;
      mml[0] = (finalL-dmml*2); //-2/8
      for( i=1; i<OctLinesCnt; i++)
      {
        mml[i] = mml[i-1] + dmml;
      }
        
      //
      //
      //
      //
      //
           
      for( i=0; i<OctLinesCnt; i++ )
      {
         CreateBaby(i,mml[i],STYLE_SOLID,mml_clr[i],mml_wdth[i]);
         buff_str = "mml_txt"+i;
            if(ObjectFind(buff_str) == -1)
               ObjectCreate(buff_str, OBJ_TEXT, 0, Time[mml_shft], mml_shft);
               ObjectSetText(buff_str, "                              "+ln_txt[i]+" @ "+DoubleToStr(mml[i],Digits), 8, "Arial", mml_clr[i]);
               ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);
      }

      //Babylines
      double b222,b224,b226;
      double b112,b114,b116;
      double b02,b04,b06;
      double b12,b14,b16;
      double b22,b24,b26;
      double b32,b34,b36;
      double b42,b44,b46;
      double b52,b54,b56;
      double b62,b64,b66;
      double b72,b74,b76;
      double b82,b84,b86;
      double b92,b94,b96;

      double x0 = mml[0];
      double x1 = mml[1];
      double x2 = mml[2];
      double x3 = mml[3];
      double x4 = mml[4];
      double x5 = mml[5];
      double x6 = mml[6];
      double x7 = mml[7];
      double x8 = mml[8];
      double x9 = mml[9];
      double x10 = mml[10];
      double x11 = mml[11];
      double x12 = mml[12];

      b222 = ((x1-x0)/4)+x0;
      b224 = ((x1-x0)/2)+x0;
      b226 = ((x1-x0)/4)*3+x0;

      b112 = ((x2-x1)/4)+x1;
      b114 = ((x2-x1)/2)+x1;
      b116 = ((x2-x1)/4)*3+x1;

      b02 = ((x3-x2)/4)+x2;
      b04 = ((x3-x2)/2)+x2;
      b06 = ((x3-x2)/4)*3+x2;

      b12 = ((x4-x3)/4)+x3;
      b14 = ((x4-x3)/2)+x3;
      b16 = ((x4-x3)/4)*3+x3;

      b22 = ((x5-x4)/4)+x4;
      b24 = ((x5-x4)/2)+x4;
      b26 = ((x5-x4)/4)*3+x4;

      b32 = ((x6-x5)/4)+x5;
      b34 = ((x6-x5)/2)+x5;
      b36 = ((x6-x5)/4)*3+x5;

      b42 = ((x7-x6)/4)+x6;
      b44 = ((x7-x6)/2)+x6;
      b46 = ((x7-x6)/4)*3+x6;

      b52 = ((x8-x7)/4)+x7;
      b54 = ((x8-x7)/2)+x7;
      b56 = ((x8-x7)/4)*3+x7;

      b62 = ((x9-x8)/4)+x8;
      b64 = ((x9-x8)/2)+x8;
      b66 = ((x9-x8)/4)*3+x8;

      b72 = ((x10-x9)/4)+x9;
      b74 = ((x10-x9)/2)+x9;
      b76 = ((x10-x9)/4)*3+x9;

      b82 = ((x11-x10)/4)+x10;
      b84 = ((x11-x10)/2)+x10;
      b86 = ((x11-x10)/4)*3+x10;

      b92 = ((x12-x11)/4)+x11;
      b94 = ((x12-x11)/2)+x11;
      b96 = ((x12-x11)/4)*3+x11;
      //---------------------------------------------------------
      if (babylines)
      {
      CreateBaby(14,b222,babyLinesStyle);
      CreateBaby(15,b226,babyLinesStyle);
      CreateBaby(16,b112,babyLinesStyle);
      CreateBaby(17,b116,babyLinesStyle);
      CreateBaby(18,b02,babyLinesStyle);
      CreateBaby(19,b06,babyLinesStyle);
      CreateBaby(20,b12,babyLinesStyle);
      CreateBaby(21,b16,babyLinesStyle);
      CreateBaby(22,b22,babyLinesStyle);
      CreateBaby(23,b26,babyLinesStyle);
      CreateBaby(24,b32,babyLinesStyle);
      CreateBaby(25,b36,babyLinesStyle);
      CreateBaby(26,b42,babyLinesStyle);
      CreateBaby(27,b46,babyLinesStyle);
      CreateBaby(28,b52,babyLinesStyle);
      CreateBaby(29,b56,babyLinesStyle);
      CreateBaby(30,b62,babyLinesStyle);
      CreateBaby(31,b66,babyLinesStyle);
      CreateBaby(32,b72,babyLinesStyle);
      CreateBaby(33,b76,babyLinesStyle);
      CreateBaby(34,b82,babyLinesStyle);
      CreateBaby(35,b86,babyLinesStyle);
      CreateBaby(36,b92,babyLinesStyle);
      CreateBaby(37,b96,babyLinesStyle);
      }
      if (fiftyPercentLine)
      {
      CreateBaby(38,b224,fiftyPercentLineStyle);
      CreateBaby(39,b114,fiftyPercentLineStyle);
      CreateBaby(40,b04 ,fiftyPercentLineStyle);
      CreateBaby(41,b14 ,fiftyPercentLineStyle);
      CreateBaby(42,b24 ,fiftyPercentLineStyle);
      CreateBaby(43,b34 ,fiftyPercentLineStyle);
      CreateBaby(44,b44 ,fiftyPercentLineStyle);
      CreateBaby(45,b54 ,fiftyPercentLineStyle);
      CreateBaby(46,b64 ,fiftyPercentLineStyle);
      CreateBaby(47,b74 ,fiftyPercentLineStyle);
      CreateBaby(48,b84 ,fiftyPercentLineStyle);
      CreateBaby(49,b94 ,fiftyPercentLineStyle);
      }

      nTime    = Time[0];
      CurPeriod= Period();
   
      string buff_str = "LR_LatestCulcBar";
      if(ObjectFind(buff_str) == -1) {
         ObjectCreate(buff_str, OBJ_ARROW,0, Time[StepBack], Low[StepBack]-2*pointvalue );
         ObjectSet(buff_str, OBJPROP_ARROWCODE, MarkNumber);
         ObjectSet(buff_str, OBJPROP_COLOR, MarkColor);
      }
      else {
      ObjectMove(buff_str, 0, Time[StepBack], Low[StepBack]-2*pointvalue );
      }
   }
   
   //
   //
   //
   //
   //
   
   datetime cTime = iTime(NULL,PERIOD_W1,0);
   
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;
   
      
   string cName = ForexTSD_Calendar();  
      
      if(cName != "")
      {   
      ReadnPlotCalendar(cName);
      fTime = false;
      prevTime = cTime;
      }
      else 
      {
     
      return(0);
      }
  
   }
   
   if(AlertMode && TimeToAlert() && TimeCurrent() > nnTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nnTime = TimeCurrent() + AlertTimeGap*60;
   }
   
   ChartComment(); 
     
   //
   //
   //
   //
   //
    
   if (MMalertsOn)          CheckTouches();
   if (MMalertsShowTouched) ShowCandles();
   manageAlerts();
   return(0);
}
 
       



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts() 
{
   if (alertsOn) 
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar));
      
      //
      //
      //
      //
      //
      
      if (trend[whichBar] != trend[whichBar+1]) 
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat) 
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

        message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Mandarine trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Mandarine"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

double wrk[][80];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
  
void CreateBaby(string ID, double value,int style=STYLE_SOLID,color clr=DarkSlateGray,int width=0)
{
   string name = "MMline"+ID;

   if (ObjectFind(name) == -1)
      ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,clr);
         ObjectSet(name,OBJPROP_STYLE,style);
         ObjectSet(name,OBJPROP_WIDTH,width);
         ObjectSet(name,OBJPROP_RAY,false);
         ObjectMove(name,0,Time[0],value);
         ObjectMove(name,1,iTime(NULL,ShowPeriod,ShowDays),value);

   //
   //
   //
   //
   //

   values[StrToInteger(ID)] = value;         
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void CheckTouches()
{
   for (i=0;i<50;i++) { if (CheckIfTouched(values[i])!=0) break; }         
}
int CheckIfTouched(double compareTo,bool checking=false,int forBar=0)
{
   int    answer = 0;
   double diff   = NormalizeDouble(MMalertsTolerance*pointvalue,Digits);
   double correction;
   double highDiff;
   double lowDiff;
   
   if (touchChanell)
      {
         correction = NormalizeDouble(MMalertsTolerance*pointvalue,  Digits);
         diff       = NormalizeDouble(MMalertsTolerance*pointvalue*2,Digits);
      }         
   else  correction = 0.00;    
   //
   //
   //
   //
   //
      
   int add;
      if (alertsOnCurrent) add = 0;
      else                 add = 1;      
      double value = NormalizeDouble(compareTo,Digits);
          highDiff = NormalizeDouble((value+correction)-High[add+forBar],Digits);
          lowDiff  = NormalizeDouble(Low[add+forBar]-(value-correction),Digits);
          
   //
   //
   //
   //
   //
   
   if (checking)
      {
         if ((highDiff >= 0) && (highDiff <= diff)) answer = -1;
         if ((lowDiff  >= 0) && (lowDiff  <= diff)) answer =  1;
      }
   else
      {
         while (true)
         {
            if ((highDiff >= 0) && (highDiff <= diff)) { answer = -1; doMMAlert("MM line touched from down"); break; }
            if ((lowDiff  >= 0) && (lowDiff  <= diff)) { answer =  1; doMMAlert("MM line touched from up");   break; }
                                                                                               break;
         }            
      }
   return(answer);
}

//
//
//
//
//

void doMMAlert(string MMdoWhat)
{
   static string   MMpreviousAlert="nothing";
   static datetime MMpreviousTime;
   string MMmessage;

      if (MMpreviousAlert != MMdoWhat || MMpreviousTime != Time[0]) {
          MMpreviousAlert  = MMdoWhat;
          MMpreviousTime   = Time[0];

          //
          //
          //
          //
          //

          MMmessage =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Murrey math ",MMdoWhat);
             if (MMalertsMessage) Alert(MMmessage);
             if (MMalertsEmail)   SendMail(StringConcatenate(Symbol()," Murrey math line crossing"),MMmessage);
             if (MMalertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void deleteCandles()
{
   while(totalCandles>0) { ObjectDelete(StringConcatenate(windowID,"c-",totalCandles)); totalCandles -= 1; }
}

//
//
//
//
//

void ShowCandles()
{
   deleteCandles();
   for (int i = 0;i<barsToShowCandles;i++)
   {
      if (iTime(NULL,ShowPeriod,ShowDays)<Time[i])
         for (int k=0; k<50; k++) if(CheckSingle(values[k],i,k)) break;
   }
      
}

//
//
//
//
//

bool CheckSingle(double array,int shift,int k)
{
   int result = CheckIfTouched(array,true,shift);
   if (result != 0)
      {
         if (alertsOnCurrent) DrawCandle(shift  ,result,k);
         else                 DrawCandle(shift+1,result,k);
         return(true);
      }
   else
      {
         return(false);
      }         
}

//
//
//
//
//

void DrawCandle(int shift,int upDown,int index)
{
   datetime time  = Time[shift];
   double   high  = iHigh (NULL,0,shift);
   double   low   = iLow  (NULL,0,shift);
   double   open  = iOpen (NULL,0,shift);
   double   close = iClose(NULL,0,shift);
   string name;


   
   totalCandles += 1;
   name    = windowID+"c-"+totalCandles;
      ObjectCreate(name,OBJ_TREND,0,time,high,time,low);
         ObjectSet(name,OBJPROP_COLOR,WickColor);
         ObjectSet(name,OBJPROP_RAY  ,false);
      
   //
   //
   //
   //
   //
         
   totalCandles += 1;
   name    = windowID+"c-"+totalCandles;
      ObjectCreate(name,OBJ_TREND,0,time,open,time,close);
         ObjectSet(name,OBJPROP_WIDTH,CandleWidth);
         ObjectSet(name,OBJPROP_RAY  ,false);
         if (index > 12)
            {
               if (upDown>0)
                     ObjectSet(name,OBJPROP_COLOR,BabyBarUpColor);
               else  ObjectSet(name,OBJPROP_COLOR,BabyBarDownColor);
            }               
         else
            {
               if (upDown>0)
                     ObjectSet(name,OBJPROP_COLOR,BarUpColor);
               else  ObjectSet(name,OBJPROP_COLOR,BarDownColor);
            }               
                     
}

//
//
//
//
//

void ReadnPlotCalendar(string fName)
{    
   int i,handle;
   bool rates=false;
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
      
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]        = FileReadString(handle);          
   sTime[i]        = FileReadString(handle);         
   sCurrency[i]    = FileReadString(handle);      
   sDescription[i] = FileReadString(handle);   
   sRating[i]      = FileReadString(handle);        
   sActual[i]      = FileReadString(handle);       
   sForecast[i]    = FileReadString(handle);      
   sPrevious[i]    = FileReadString(handle);                
   
   int rating      = StrToInteger(sRating[i]);
   rates = rating <= MaxRating && rating >= MinRating;
      
   if(!rates) continue;  
   
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   if(rating == 3) sImpact[i] = "High";
   if(rating == 2) sImpact[i] = "Medium";
   if(rating == 1) sImpact[i] = "Low";
   
   string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i]+" "+sActual[i]+" "+sForecast[i];
   
   
   color c=Yellow ;
   
   if (sCurrency[i] == "USD") c = Blue;  
   if (sCurrency[i] == "EUR") c = Pink; 
   if (sCurrency[i] == "GBP") c = Red;
   if (sCurrency[i] == "JPY") c = Orange;            
   if (sCurrency[i] == "AUD") c = Green;       
   if (sCurrency[i] == "CAD") c = Gray;
   if (sCurrency[i] == "CHF") c = Green;
   if (sCurrency[i] == "NZD") c = Lime;  
      
   if (DisplayText)
   {
   ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
   ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
   ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
   ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
   }
          
   if (DisplayLine)
   {         
   ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
   ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
   ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
   ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
   ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
   }
      
   i++;
   }
   NewsNum = i;
   
return(0);
}

//
//
//
//
//

void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
      {
      _GetLastError = GetLastError();
   
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
      {
      _GetLastError = GetLastError();
     
      }
   }
}

//
//
//
//
//

string ForexTSD_Calendar()
{
   if(!UseStartDate)
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   else 
   StartWeek = StartDate;
   
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle = FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}

//
//
//
//
//

void ChartComment()
{
   
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   for (int i=0; i<=NewsNum-1; i++)
   { 
      if(TimeCurrent()> dt[i-1] && TimeCurrent() <= dt[i])
      {
      OpenTime = dt[i];
      string upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sActual[i]+" Forecast=" + sForecast[i];  
      string upcomTime = TimeToStr(dt[i]);  
         
         if (i-1 >= 0)
         {
         string prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i-1]+" Actual=" + sActual[i-1]; 
         string prevTime = TimeToStr(dt[i-1]);
         }
      }
      
      if(OpenTime > 0 && OpenTime < dt[i])
      {
      string nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sActual[i]+" Forecast=" + sForecast[i];  
      string nextTime = TimeToStr(dt[i]);
      break;
      }
   }
      
   sComment = sp;
   sComment = sComment+"Mandarine Trading System"+NL; 
   sComment = sComment+"ForexTSD Calendar:"+NL;
   
   if(TimeZone >= 0)
   sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   sComment = sComment+"NEWS :" + NL;
   sComment = sComment+"Previous = " + prevTime  +" "+prevNews  + NL;
   sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   sComment = sComment+"Next     = " + nextTime  +" "+nextNews  + NL;
   sComment = sComment+sp;
  
   Comment(sComment);
}      

//
//
//
//
//

bool TimeToAlert()
{
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
   
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}